import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["skeleton"],
    _excluded2 = ["skeleton"],
    _excluded3 = ["skeleton"],
    _excluded4 = ["skeleton"];
import { SkeletonEvents } from '@alilc/lowcode-editor-skeleton';
import { skeletonSymbol } from './symbols';

var Skeleton = /*#__PURE__*/function () {
  function Skeleton(skeleton) {
    this[skeletonSymbol] = void 0;
    this[skeletonSymbol] = skeleton;
  }
  /**
   * 增加一个面板实例
   * @param config
   * @param extraConfig
   * @returns
   */


  var _proto = Skeleton.prototype;

  _proto.add = function add(config, extraConfig) {
    return this[skeletonSymbol].add(config, extraConfig);
  }
  /**
   * 移除一个面板实例
   * @param config
   * @returns
   */
  ;

  _proto.remove = function remove(config) {
    var area = config.area,
        name = config.name;
    var skeleton = this[skeletonSymbol];
    if (!normalizeArea(area)) return;
    skeleton[normalizeArea(area)].container.remove(name);
  }
  /**
   * 显示面板
   * @param name
   */
  ;

  _proto.showPanel = function showPanel(name) {
    var _this$skeletonSymbol$;

    (_this$skeletonSymbol$ = this[skeletonSymbol].getPanel(name)) === null || _this$skeletonSymbol$ === void 0 ? void 0 : _this$skeletonSymbol$.show();
  }
  /**
   * 隐藏面板
   * @param name
   */
  ;

  _proto.hidePanel = function hidePanel(name) {
    var _this$skeletonSymbol$2;

    (_this$skeletonSymbol$2 = this[skeletonSymbol].getPanel(name)) === null || _this$skeletonSymbol$2 === void 0 ? void 0 : _this$skeletonSymbol$2.hide();
  }
  /**
   * 显示 widget
   * @param name
   */
  ;

  _proto.showWidget = function showWidget(name) {
    var _this$skeletonSymbol$3;

    (_this$skeletonSymbol$3 = this[skeletonSymbol].getWidget(name)) === null || _this$skeletonSymbol$3 === void 0 ? void 0 : _this$skeletonSymbol$3.show();
  }
  /**
   * enable widget
   * @param name
   */
  ;

  _proto.enableWidget = function enableWidget(name) {
    var _this$skeletonSymbol$4, _this$skeletonSymbol$5;

    (_this$skeletonSymbol$4 = this[skeletonSymbol].getWidget(name)) === null || _this$skeletonSymbol$4 === void 0 ? void 0 : (_this$skeletonSymbol$5 = _this$skeletonSymbol$4.enable) === null || _this$skeletonSymbol$5 === void 0 ? void 0 : _this$skeletonSymbol$5.call(_this$skeletonSymbol$4);
  }
  /**
   * 隐藏 widget
   * @param name
   */
  ;

  _proto.hideWidget = function hideWidget(name) {
    var _this$skeletonSymbol$6;

    (_this$skeletonSymbol$6 = this[skeletonSymbol].getWidget(name)) === null || _this$skeletonSymbol$6 === void 0 ? void 0 : _this$skeletonSymbol$6.hide();
  }
  /**
   * disable widget，不可点击
   * @param name
   */
  ;

  _proto.disableWidget = function disableWidget(name) {
    var _this$skeletonSymbol$7, _this$skeletonSymbol$8;

    (_this$skeletonSymbol$7 = this[skeletonSymbol].getWidget(name)) === null || _this$skeletonSymbol$7 === void 0 ? void 0 : (_this$skeletonSymbol$8 = _this$skeletonSymbol$7.disable) === null || _this$skeletonSymbol$8 === void 0 ? void 0 : _this$skeletonSymbol$8.call(_this$skeletonSymbol$7);
  }
  /**
   * 监听 panel 显示事件
   * @param listener
   * @returns
   */
  ;

  _proto.onShowPanel = function onShowPanel(listener) {
    var editor = this[skeletonSymbol].editor;
    editor.on(SkeletonEvents.PANEL_SHOW, function (name, panel) {
      // 不泄漏 skeleton
      var skeleton = panel.skeleton,
          restPanel = _objectWithoutPropertiesLoose(panel, _excluded);

      listener(name, restPanel);
    });
    return function () {
      return editor.off(SkeletonEvents.PANEL_SHOW, listener);
    };
  }
  /**
   * 监听 panel 隐藏事件
   * @param listener
   * @returns
   */
  ;

  _proto.onHidePanel = function onHidePanel(listener) {
    var editor = this[skeletonSymbol].editor;
    editor.on(SkeletonEvents.PANEL_HIDE, function (name, panel) {
      // 不泄漏 skeleton
      var skeleton = panel.skeleton,
          restPanel = _objectWithoutPropertiesLoose(panel, _excluded2);

      listener(name, restPanel);
    });
    return function () {
      return editor.off(SkeletonEvents.PANEL_HIDE, listener);
    };
  }
  /**
   * 监听 widget 显示事件
   * @param listener
   * @returns
   */
  ;

  _proto.onShowWidget = function onShowWidget(listener) {
    var editor = this[skeletonSymbol].editor;
    editor.on(SkeletonEvents.WIDGET_SHOW, function (name, panel) {
      // 不泄漏 skeleton
      var skeleton = panel.skeleton,
          rest = _objectWithoutPropertiesLoose(panel, _excluded3);

      listener(name, rest);
    });
    return function () {
      return editor.off(SkeletonEvents.WIDGET_SHOW, listener);
    };
  }
  /**
   * 监听 widget 隐藏事件
   * @param listener
   * @returns
   */
  ;

  _proto.onHideWidget = function onHideWidget(listener) {
    var editor = this[skeletonSymbol].editor;
    editor.on(SkeletonEvents.WIDGET_HIDE, function (name, panel) {
      // 不泄漏 skeleton
      var skeleton = panel.skeleton,
          rest = _objectWithoutPropertiesLoose(panel, _excluded4);

      listener(name, rest);
    });
    return function () {
      return editor.off(SkeletonEvents.WIDGET_HIDE, listener);
    };
  };

  return Skeleton;
}();

export { Skeleton as default };

function normalizeArea(area) {
  switch (area) {
    case 'leftArea':
    case 'left':
      return 'leftArea';

    case 'rightArea':
    case 'right':
      return 'rightArea';

    case 'topArea':
    case 'top':
      return 'topArea';

    case 'toolbar':
      return 'toolbar';

    case 'mainArea':
    case 'main':
    case 'center':
    case 'centerArea':
      return 'mainArea';

    case 'bottomArea':
    case 'bottom':
      return 'bottomArea';

    case 'leftFixedArea':
      return 'leftFixedArea';

    case 'leftFloatArea':
      return 'leftFloatArea';

    case 'stages':
      return 'stages';

    default:
      throw new Error(area + " not supported");
  }
}