"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _node = _interopRequireDefault(require("./node"));

var _symbols = require("./symbols");

var Selection = /*#__PURE__*/function () {
  function Selection(document) {
    this[_symbols.documentSymbol] = void 0;
    this[_symbols.selectionSymbol] = void 0;
    this[_symbols.documentSymbol] = document;
    this[_symbols.selectionSymbol] = document.selection;
  }
  /**
   * 返回选中的节点 id
   */


  var _proto = Selection.prototype;

  /**
   * 选中指定节点（覆盖方式）
   * @param id
   */
  _proto.select = function select(id) {
    this[_symbols.selectionSymbol].select(id);
  }
  /**
   * 批量选中指定节点们
   * @param ids
   */
  ;

  _proto.selectAll = function selectAll(ids) {
    this[_symbols.selectionSymbol].selectAll(ids);
  }
  /**
   * 移除选中的指定节点
   * @param id
   */
  ;

  _proto.remove = function remove(id) {
    this[_symbols.selectionSymbol].remove(id);
  }
  /**
   * 清除所有选中节点
   */
  ;

  _proto.clear = function clear() {
    this[_symbols.selectionSymbol].clear();
  }
  /**
   * 判断是否选中了指定节点
   * @param id
   * @returns
   */
  ;

  _proto.has = function has(id) {
    return this[_symbols.selectionSymbol].has(id);
  }
  /**
   * 选中指定节点（增量方式）
   * @param id
   */
  ;

  _proto.add = function add(id) {
    this[_symbols.selectionSymbol].add(id);
  }
  /**
   * 获取选中的节点实例
   * @returns
   */
  ;

  _proto.getNodes = function getNodes() {
    return this[_symbols.selectionSymbol].getNodes().map(function (node) {
      return _node["default"].create(node);
    });
  };

  (0, _createClass2["default"])(Selection, [{
    key: "selected",
    get: function get() {
      return this[_symbols.selectionSymbol].selected;
    }
    /**
     * return selected Node instance
     */

  }, {
    key: "node",
    get: function get() {
      return this.getNodes()[0];
    }
  }]);
  return Selection;
}();

exports["default"] = Selection;